task count {
  File gene_abundance
  Array[File] ballgown
  String base=basename(gene_abundance, ".gene.abundance.txt")
  String docker
  String cluster
  String disk_size
  Int count_length

  command <<<
    mkdir -p /cromwell_root/tmp/ballgown/${base}
    cp -r ${sep=" " ballgown} /cromwell_root/tmp/ballgown/${base}
    count -i /cromwell_root/tmp/ballgown -l ${count_length} -g ${base}_gene_count_matrix.csv -t ${base}_transcript_count_matrix.csv
  >>>
  
  runtime {
    docker: docker
    cluster: cluster
    systemDisk: "cloud_ssd 40"
    dataDisk: "cloud_ssd " + disk_size + " /cromwell_root/"
  }
  
  output {
    File mat_expression_genecount="${base}_gene_count_matrix.csv"
    File mat_expression_transcriptcount="${base}_transcript_count_matrix.csv"
  }
}