task fastp {
  File read1
  File read2
  String read1name=sub(basename(read1),"\\.\\S+$", "")
  String read2name=sub(basename(read2),"\\.\\S+$", "")
  String sample_name=sub(basename(read1),"\\_*1.\\S+$", "")
  String adapter_sequence
  String adapter_sequence_r2
  String docker
  String cluster
  String disk_size
  String trim_adapter

command <<<
    nt=$(nproc)
    
    ## Trim
    if [ "${trim_adapter}" != 'true' ]; then
    cp ${read1} ${read1name}.fq.gz
    cp ${read2} ${read2name}.fq.gz
    else
    fastp --thread $nt --adapter_sequence ${adapter_sequence} --adapter_sequence_r2 ${adapter_sequence_r2} --detect_adapter_for_pe -i ${read1} -I ${read2} -o ${read1name}.fq.gz -O ${read2name}.fq.gz -j ${sample_name}.json -h ${sample_name}.html
    fi
  >>>
  
  runtime { 
    docker: docker
    cluster: cluster
    systemDisk: "cloud_ssd 40"
    dataDisk: "cloud_ssd " + disk_size + " /cromwell_root/"
  }

  output {
    File json = "${sample_name}.json"
    File report = "${sample_name}.html"
    File trim_R1 = "${read1name}.fq.gz"
    File trim_R2 = "${read2name}.fq.gz"
  }
}